# -*- coding: utf-8 -*-
"""
Created on Fry Jan 1 12:33:57 2021

@author: Klaus Reinold
"""

from graphics_and_games_klassen import Figur, Ereignisbehandlung, Rechteck
   

class Auto(Figur): 
    """
    Beschreibung eines Autos
    """
    


    def __init__(self, farbe):
        """
        Initialisierung für Objekte der Klasse Auto
        """
        super().__init__()
        self.FigurteilFestlegenRechteck(-30, -50, 60, 100, farbe)
        self.FigurteilFestlegenRechteck(-28, 10, 56, 20, "blau")
        self.FigurteilFestlegenEllipse(-20, 46, 8, 4, "weiss")
        self.FigurteilFestlegenEllipse(12, 46, 8, 4, "weiss")
        self.GroesseSetzen(80)
    
    
    

  



class Geisterauto(Auto):
    """
    Die entgegenkommenden Autos
    """

    

    def __init__(self, fahrspurNeu, farbe, y):
        """
        Initialisierung für Objekte der Klasse Geisterauto
        """    
        super().__init__(farbe)
        self.fahrspur = fahrspurNeu
        self.yPos = y
        self.PositionSetzen(self.fahrspur*80 + 40, self.yPos)
    
    

    def Fahren(self):
        """
        Bewegungsmethode des Autos
        """
        self.yPos = self.yPos + 5
        if self.yPos > 600: 
            self.yPos = -50
        
        self.PositionSetzen(self.fahrspur*80 + 40, self.yPos)
    

    




class Spielerauto(Auto):
    """
    Das tastaturgesteuerte Auto des Spielers
    """


    def __init__(self):
        """
        Initialisierung für Objekte der Klasse Spielerauto
        """    
        super().__init__("braun")
        self.Drehen(180)
        self.xPos = 40
        self.yPos = 460
        self.PositionSetzen(self.xPos, self.yPos)
    


    def Bewegen(self, richtung):
        """
        Bewegung des Spielerautos nach links/rechts
        """   
        if richtung == "links":
            if self.xPos > 0:
                self.xPos = self.xPos - 40
        else:
            if richtung == "rechts":
                if self.xPos < 240:     
                    self.xPos = self.xPos + 40
            
        
        self.PositionSetzen(self.xPos, self.yPos)
    






class Spiel(Ereignisbehandlung):
    """
    Spielsteuerung
    """


    def __init__(self):
        """
        Initialisierung des Spiels
        """
        super().__init__()
        self.TaktdauerSetzen(150)
        strasse = Rechteck()
        strasse.GroesseSetzen(240, 600)
        strasse.FarbeSetzen("grau")
        strasse.PositionSetzen(0,0)

        for i in range(1, 3):
            for j in range(0, 14):
            
                fahrbahnmarkierung = Rechteck()
                fahrbahnmarkierung.FarbeSetzen("weiß")
                fahrbahnmarkierung.GroesseSetzen(4,20)
                fahrbahnmarkierung.PositionSetzen(80*i-2,40*j)
            

        self.auto1 = Geisterauto(0, "rot", -200)
        self.auto2 = Geisterauto(1, "grün",50)
        self.auto3 = Geisterauto(2, "magenta", 300)
        self.spielerauto = Spielerauto()
        self.Starten()


    

 
    def AktionAusfuehren(self):
        """
        Taktsteuerung der Geisterautos
        """       
        self.auto1.Fahren() 
        self.auto2.ypos = self.auto2.yPos + 5
        self.auto3.Fahren()
        if self.spielerauto.BeruehrtObjekt(self.auto1) or self.spielerauto.BeruehrtObjekt(self.auto2) or self.spielerauto.BeruehrtObjekt(self.auto3):
            self.Anhalten()
        
 


    def TasteGedrueckt(self,taste):
        """
        Tastatursteuerung des Spielerautos
        """      
        if taste == "left":       
            self.spielerauto.xPos = self.spielerauto.xPos - 40


        if taste == "right":
            self.spielerauto.Bewegen("rechts")
            
            
Spiel()