# -*- coding: utf-8 -*-
"""
Created on Fry Jan 1 12:33:57 2021

@author: Klaus Reinold
"""

from graphics_and_games_klassen import Rechteck, Kreis, Ereignisbehandlung
   


class Lampe:
    """
    Beschreibt eine Lampe für eine Ampel
    """

    

    def __init__(self, x, y, farbe):
        """
        Legt eine Lampe an der gegebenen Position an.
        -- Parameter x x-Koordinate der Lampe
        -- Parameter y y-Koordinate der Lampe
        -- Parameter farbe Farbe der Lampe
        """    
        self.rahmen = Rechteck()
        self.rahmen.PositionSetzen(x, y)
        self.rahmen.GroesseSetzen(20, 20)
        self.rahmen.FarbeSetzen("schwarz")
        self.fläche = Rechteck()
        self.fläche.PositionSetzen(x + 1, y + 1)
        self.fläche.GroesseSetzen(18, 18)
        self.fläche.FarbeSetzen("weiß")
        self.anzeige = Kreis()
        self.anzeige.RadiusSetzen(5)
        self.anzeige.PositionSetzen(x + 10, y + 10)
        self.anzeige.FarbeSetzen(farbe)
        self.farbe = farbe
    
    

    def Einschalten(self):
        """
        Schaltet die Lampe ein
        """    
        self.anzeige.FarbeSetzen(self.farbe)
    
    

    def Ausschalten(self):
        """
        Schaltet die Lampe aus
        """    
        self.anzeige.FarbeSetzen("schwarz")
    

    def PositionSetzen(self, x, y):
        """
        Setzt die Position der Lampe
        -- Parameter x x-Koordinate der Lampe
        -- Parameter y y-Koordinate der Lampe
        """   
        self.rahmen.PositionSetzen(x, y)
        self.fläche.PositionSetzen(x + 1, y + 1)
        self.anzeige.PositionSetzen(x + 10, y + 10)
    



class Ampel(Ereignisbehandlung):
    """
    Eine Ampel verwendet zur Anzeige drei Lampen.
    Die Ampel verwaltet ihre Position als Ganzes, ihre Ausrichtung und auch die 
    nach den Verkehrsregeln möglichen Ampelphasen.
    
    Mögliche Werte der Ampelphase sind die in Deutschland erlaubten Ampelphasen 
    grün, gelb, rot und rotgelb.
    """
   

    def __init__(self, x = 100, y = 100):
        """
        Initialisierung für Objekte der Klasse Ampel 
        mit folgenden Eingabewerten.
        -- Parameter x - x-Position
        -- Parameter y - y-Position
        """
        super().__init__()
        self.ampelphase = "rot"
        self.wartezeit = 0
        
        self.lampeOben = Lampe(x, y, "rot")
        self.lampeMitte = Lampe(x, y + 20, "gelb")
        # Ergänzen
        self.lampeOben.Einschalten()
        self.lampeMitte.Ausschalten()
        # Ergänzen
    
    

    def PositionSetzen(self, x, y):
        """
        Setzt die Position der Ampel.
        -- Parameter x x-Position
        -- Parameter y y-Position
        """    
        if x<=800 and x>=0 and y<=600 and y>=0:
        
            self.lampeOben.PositionSetzen(x, y)
            self.lampeMitte.PositionSetzen(x, y + 20)
            #Ergänzen
        
    
           

    def GrünSetzen(self):
        """
        Setzt die Ampel auf grün.
        """    
        self.ampelphase = "grün"
        self.lampeOben.Ausschalten()
        self.lampeMitte.Ausschalten()
        #Ergänzen
    
    
    
    def AktionAusfuehren(self):
        """
        Methode kann zur Taktsteuerung genutzt werden (Aufruf der Methode Weiterschalten)
        Profis können mit dem Attribut wartezeit die Ampel zudem so steuern, dass die Phasen rot und grün
        lange, die Phasen gelb und rotgelb kurz sind. 
        """
        pass
                
a = Ampel()            