# -*- coding: utf-8 -*-
"""
Created on Fry Jan 1 12:33:57 2021

@author: Klaus Reinold
"""

from graphics_and_games_klassen import Ereignisbehandlung, Text
   


class Nummernanzeige:
    """
    Nummernanzeige mit zwei Ziffern
    """

    def __init__(self, obergrenzeNeu):
        """
        Der Initialisierung belegt die Obergrenze und setzt den Startwert
        -- Parameter obergrenzeNeu die gewünschte Obergrenze
        """    
        self.obergrenze = obergrenzeNeu
        self.wert = 0
    


    def ObergrenzeGeben(self):
        """
        Gibt die eingestellte Obergrenze zurück
        -- returns eingestellte Obergrenze
        """    
        return self.obergrenze
    


    def WertGeben(self):
        """
        Gibt den aktuellen Wert zurück
        -- returns aktueller Wert
        """   
        return self.wert
    


    def WertSetzen(self, wertNeu):
        """
        Setzt den Wert der Anzeige
        -- Parameter wertNeu neuer Wert für die Anzeige
        """    
        if (wertNeu >= 0 and wertNeu < self.obergrenze):
        
            self.wert = wertNeu
        
    


    def Erhoehen(self):
        """
        Erhöht den Wert der Anzeige (um 1):
        Bei Erreichen der Obergrenze wird auf 0 zurück gesetzt.
        """   
        self.wert = self.wert + 1
        if (self.wert == self.obergrenze):
            self.wert = 0 
        
    


    def Erniedrigen(self):
        """
        Erniedrigt den Wert der Anzeige (um 1):
        Bei Erreichen der 0 wird auf die Obergrenze zurück gesetzt.
        """   
        self.wert = self.wert - 1
        if (self.wert < 0):
        
            self.wert = self.obergrenze-1
        
    




class Uhr(Ereignisbehandlung):
    """
    Digitaluhr
    """


    def __init__(self):
        """
        Initialisierung
        """    
        super().__init__()
        self.minuten =   Nummernanzeige(60)
        self.sekunden =   Nummernanzeige(60)

        #Darstellung
        self.anzeige = Text()
        self.anzeige.PositionSetzen(100,100)
        self.anzeige.TextGroesseSetzen(40)
        self.anzeige.TextSetzen(self.AnzeigeAusgeben())
        self.TaktdauerSetzen(1000)
    

    def AnzeigeAusgeben(self):
        """
        Wandelt die Anzeige in eine Zeichenkette um
        -- return Anzeige als Zeichenkette
        """   
        anzeige = self.ZweistelligeZahlAlsTextErstellen(self.minuten.WertGeben()) + ":" + self.ZweistelligeZahlAlsTextErstellen(self.sekunden.WertGeben())
        return anzeige
    


    def ZweistelligeZahlAlsTextErstellen(self, zahl):
        """
        Wandet eine zweistellige Zahl in einen mit 2 Zeichen um
        -- Parameter zahl die umzuwandelnde Zahl
        -- return die zugehörige Zeichenkette
        """    
        if (zahl < 10):      
            return "0" + str(zahl)     
        else:   
            return str(zahl)
        
    
    def AktionAusfuehren(self):
        """
        Schaltet die Uhr um eine Sekunde weiter
        """   
        self.sekunden.Erhoehen()
        if self.sekunden.WertGeben() == 0:
            self.minuten.Erhoehen()
        self.anzeige.TextSetzen(self.AnzeigeAusgeben())
    



u = Uhr()